//
// This is a generated file, do not edit!
// Generated by R.swift, see https://github.com/mac-cain13/R.swift
//

import Foundation
import Rswift
import UIKit

/// This `R` struct is generated and contains references to static resources.
struct R: Rswift.Validatable {
  fileprivate static let applicationLocale = hostingBundle.preferredLocalizations.first.flatMap { Locale(identifier: $0) } ?? Locale.current
  fileprivate static let hostingBundle = Bundle(for: R.Class.self)

  /// Find first language and bundle for which the table exists
  fileprivate static func localeBundle(tableName: String, preferredLanguages: [String]) -> (Foundation.Locale, Foundation.Bundle)? {
    // Filter preferredLanguages to localizations, use first locale
    var languages = preferredLanguages
      .map { Locale(identifier: $0) }
      .prefix(1)
      .flatMap { locale -> [String] in
        if hostingBundle.localizations.contains(locale.identifier) {
          if let language = locale.languageCode, hostingBundle.localizations.contains(language) {
            return [locale.identifier, language]
          } else {
            return [locale.identifier]
          }
        } else if let language = locale.languageCode, hostingBundle.localizations.contains(language) {
          return [language]
        } else {
          return []
        }
      }

    // If there's no languages, use development language as backstop
    if languages.isEmpty {
      if let developmentLocalization = hostingBundle.developmentLocalization {
        languages = [developmentLocalization]
      }
    } else {
      // Insert Base as second item (between locale identifier and languageCode)
      languages.insert("Base", at: 1)

      // Add development language as backstop
      if let developmentLocalization = hostingBundle.developmentLocalization {
        languages.append(developmentLocalization)
      }
    }

    // Find first language for which table exists
    // Note: key might not exist in chosen language (in that case, key will be shown)
    for language in languages {
      if let lproj = hostingBundle.url(forResource: language, withExtension: "lproj"),
         let lbundle = Bundle(url: lproj)
      {
        let strings = lbundle.url(forResource: tableName, withExtension: "strings")
        let stringsdict = lbundle.url(forResource: tableName, withExtension: "stringsdict")

        if strings != nil || stringsdict != nil {
          return (Locale(identifier: language), lbundle)
        }
      }
    }

    // If table is available in main bundle, don't look for localized resources
    let strings = hostingBundle.url(forResource: tableName, withExtension: "strings", subdirectory: nil, localization: nil)
    let stringsdict = hostingBundle.url(forResource: tableName, withExtension: "stringsdict", subdirectory: nil, localization: nil)

    if strings != nil || stringsdict != nil {
      return (applicationLocale, hostingBundle)
    }

    // If table is not found for requested languages, key will be shown
    return nil
  }

  /// Load string from Info.plist file
  fileprivate static func infoPlistString(path: [String], key: String) -> String? {
    var dict = hostingBundle.infoDictionary
    for step in path {
      guard let obj = dict?[step] as? [String: Any] else { return nil }
      dict = obj
    }
    return dict?[key] as? String
  }

  static func validate() throws {
    try intern.validate()
  }

  #if os(iOS) || os(tvOS)
  /// This `R.storyboard` struct is generated, and contains static references to 7 storyboards.
  struct storyboard {
    /// Storyboard `DetailsVC`.
    static let detailsVC = _R.storyboard.detailsVC()
    /// Storyboard `LaunchScreen`.
    static let launchScreen = _R.storyboard.launchScreen()
    /// Storyboard `MainViewController`.
    static let mainViewController = _R.storyboard.mainViewController()
    /// Storyboard `MenuVC`.
    static let menuVC = _R.storyboard.menuVC()
    /// Storyboard `PluralsVC`.
    static let pluralsVC = _R.storyboard.pluralsVC()
    /// Storyboard `SettingsVC`.
    static let settingsVC = _R.storyboard.settingsVC()
    /// Storyboard `StringsVC`.
    static let stringsVC = _R.storyboard.stringsVC()

    #if os(iOS) || os(tvOS)
    /// `UIStoryboard(name: "DetailsVC", bundle: ...)`
    static func detailsVC(_: Void = ()) -> UIKit.UIStoryboard {
      return UIKit.UIStoryboard(resource: R.storyboard.detailsVC)
    }
    #endif

    #if os(iOS) || os(tvOS)
    /// `UIStoryboard(name: "LaunchScreen", bundle: ...)`
    static func launchScreen(_: Void = ()) -> UIKit.UIStoryboard {
      return UIKit.UIStoryboard(resource: R.storyboard.launchScreen)
    }
    #endif

    #if os(iOS) || os(tvOS)
    /// `UIStoryboard(name: "MainViewController", bundle: ...)`
    static func mainViewController(_: Void = ()) -> UIKit.UIStoryboard {
      return UIKit.UIStoryboard(resource: R.storyboard.mainViewController)
    }
    #endif

    #if os(iOS) || os(tvOS)
    /// `UIStoryboard(name: "MenuVC", bundle: ...)`
    static func menuVC(_: Void = ()) -> UIKit.UIStoryboard {
      return UIKit.UIStoryboard(resource: R.storyboard.menuVC)
    }
    #endif

    #if os(iOS) || os(tvOS)
    /// `UIStoryboard(name: "PluralsVC", bundle: ...)`
    static func pluralsVC(_: Void = ()) -> UIKit.UIStoryboard {
      return UIKit.UIStoryboard(resource: R.storyboard.pluralsVC)
    }
    #endif

    #if os(iOS) || os(tvOS)
    /// `UIStoryboard(name: "SettingsVC", bundle: ...)`
    static func settingsVC(_: Void = ()) -> UIKit.UIStoryboard {
      return UIKit.UIStoryboard(resource: R.storyboard.settingsVC)
    }
    #endif

    #if os(iOS) || os(tvOS)
    /// `UIStoryboard(name: "StringsVC", bundle: ...)`
    static func stringsVC(_: Void = ()) -> UIKit.UIStoryboard {
      return UIKit.UIStoryboard(resource: R.storyboard.stringsVC)
    }
    #endif

    fileprivate init() {}
  }
  #endif

  /// This `R.file` struct is generated, and contains static references to 1 files.
  struct file {
    /// Resource file `Localizable.plist`.
    static let localizablePlist = Rswift.FileResource(bundle: R.hostingBundle, name: "Localizable", pathExtension: "plist")

    /// `bundle.url(forResource: "Localizable", withExtension: "plist")`
    static func localizablePlist(_: Void = ()) -> Foundation.URL? {
      let fileResource = R.file.localizablePlist
      return fileResource.bundle.url(forResource: fileResource)
    }

    fileprivate init() {}
  }

  /// This `R.image` struct is generated, and contains static references to 1 images.
  struct image {
    /// Image `menu`.
    static let menu = Rswift.ImageResource(bundle: R.hostingBundle, name: "menu")

    #if os(iOS) || os(tvOS)
    /// `UIImage(named: "menu", bundle: ..., traitCollection: ...)`
    static func menu(compatibleWith traitCollection: UIKit.UITraitCollection? = nil) -> UIKit.UIImage? {
      return UIKit.UIImage(resource: R.image.menu, compatibleWith: traitCollection)
    }
    #endif

    fileprivate init() {}
  }

  /// This `R.reuseIdentifier` struct is generated, and contains static references to 2 reuse identifiers.
  struct reuseIdentifier {
    /// Reuse identifier `PluralsCell`.
    static let pluralsCell: Rswift.ReuseIdentifier<PluralsCell> = Rswift.ReuseIdentifier(identifier: "PluralsCell")
    /// Reuse identifier `StringsCell`.
    static let stringsCell: Rswift.ReuseIdentifier<StringsCell> = Rswift.ReuseIdentifier(identifier: "StringsCell")

    fileprivate init() {}
  }

  /// This `R.string` struct is generated, and contains static references to 1 localization tables.
  struct string {
    /// This `R.string.localizable` struct is generated, and contains static references to 29 localization keys.
    struct localizable {
      /// en translation: Back
      ///
      /// Locales: en, de, uk
      static let back_button = Rswift.StringResource(key: "back_button", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Button [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let details_button = Rswift.StringResource(key: "details_button", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Deetails (Present) H [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let details_present_highlighted = Rswift.StringResource(key: "details_present_highlighted", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Deetails (Present) [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let details_present = Rswift.StringResource(key: "details_present", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Deetails (Push) H [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let details_push_highlighted = Rswift.StringResource(key: "details_push_highlighted", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Deetails (Push) [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let details_push = Rswift.StringResource(key: "details_push", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Details Screen [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let details_title = Rswift.StringResource(key: "details_title", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Explorer [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let menu_explorer_button_title = Rswift.StringResource(key: "menu_explorer_button_title", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Firebase [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let menu_firebase_button_title = Rswift.StringResource(key: "menu_firebase_button_title", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: First parameter - %@, second parameter - %@ [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let test_format_key_with_2_parameters = Rswift.StringResource(key: "test_format_key_with_2_parameters", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: First parameter - %@, second parameter - %@, third parameter - %@ [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let test_format_key_with_3_parameters = Rswift.StringResource(key: "test_format_key_with_3_parameters", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Formated Strings [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let menu_formated_strings_button_title = Rswift.StringResource(key: "menu_formated_strings_button_title", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: In Bundle [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let settings_in_bundle = Rswift.StringResource(key: "settings_in_bundle", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: In SDK [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let settings_in_sdk = Rswift.StringResource(key: "settings_in_sdk", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Label 123 [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let details_label = Rswift.StringResource(key: "details_label", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Main Screen [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let main_title = Rswift.StringResource(key: "main_title", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Main [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let menu_main_button_title = Rswift.StringResource(key: "menu_main_button_title", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Parameter [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let test_parameter = Rswift.StringResource(key: "test_parameter", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Placeholder [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let details_textfield_placeholder = Rswift.StringResource(key: "details_textfield_placeholder", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Plurals [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let plurals_title = Rswift.StringResource(key: "plurals_title", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Reload UI [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let main_reload_ui_button = Rswift.StringResource(key: "main_reload_ui_button", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Settings [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let menu_settings_button_title = Rswift.StringResource(key: "menu_settings_button_title", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Show Details [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let main_show_details_button = Rswift.StringResource(key: "main_show_details_button", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Strings [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let strings_title = Rswift.StringResource(key: "strings_title", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Test [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let test_key = Rswift.StringResource(key: "test_key", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Test parameter - %@ [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let test_format_key_with_1_parameter = Rswift.StringResource(key: "test_format_key_with_1_parameter", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Test parameter - %@ [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let test_with_format_key = Rswift.StringResource(key: "test_with_format_key", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Value [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let details_segmentedControl_0 = Rswift.StringResource(key: "details_segmentedControl_0", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)
      /// en translation: Value1 [BUNDLE]
      ///
      /// Locales: en, de, uk
      static let details_segmentedControl_1 = Rswift.StringResource(key: "details_segmentedControl_1", tableName: "Localizable", bundle: R.hostingBundle, locales: ["en", "de", "uk"], comment: nil)

      /// en translation: Back
      ///
      /// Locales: en, de, uk
      static func back_button(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("back_button", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "back_button"
        }

        return NSLocalizedString("back_button", bundle: bundle, comment: "")
      }

      /// en translation: Button [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func details_button(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("details_button", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "details_button"
        }

        return NSLocalizedString("details_button", bundle: bundle, comment: "")
      }

      /// en translation: Deetails (Present) H [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func details_present_highlighted(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("details_present_highlighted", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "details_present_highlighted"
        }

        return NSLocalizedString("details_present_highlighted", bundle: bundle, comment: "")
      }

      /// en translation: Deetails (Present) [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func details_present(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("details_present", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "details_present"
        }

        return NSLocalizedString("details_present", bundle: bundle, comment: "")
      }

      /// en translation: Deetails (Push) H [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func details_push_highlighted(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("details_push_highlighted", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "details_push_highlighted"
        }

        return NSLocalizedString("details_push_highlighted", bundle: bundle, comment: "")
      }

      /// en translation: Deetails (Push) [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func details_push(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("details_push", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "details_push"
        }

        return NSLocalizedString("details_push", bundle: bundle, comment: "")
      }

      /// en translation: Details Screen [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func details_title(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("details_title", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "details_title"
        }

        return NSLocalizedString("details_title", bundle: bundle, comment: "")
      }

      /// en translation: Explorer [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func menu_explorer_button_title(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("menu_explorer_button_title", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "menu_explorer_button_title"
        }

        return NSLocalizedString("menu_explorer_button_title", bundle: bundle, comment: "")
      }

      /// en translation: Firebase [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func menu_firebase_button_title(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("menu_firebase_button_title", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "menu_firebase_button_title"
        }

        return NSLocalizedString("menu_firebase_button_title", bundle: bundle, comment: "")
      }

      /// en translation: First parameter - %@, second parameter - %@ [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func test_format_key_with_2_parameters(_ value1: String, _ value2: String, preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          let format = NSLocalizedString("test_format_key_with_2_parameters", bundle: hostingBundle, comment: "")
          return String(format: format, locale: applicationLocale, value1, value2)
        }

        guard let (locale, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "test_format_key_with_2_parameters"
        }

        let format = NSLocalizedString("test_format_key_with_2_parameters", bundle: bundle, comment: "")
        return String(format: format, locale: locale, value1, value2)
      }

      /// en translation: First parameter - %@, second parameter - %@, third parameter - %@ [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func test_format_key_with_3_parameters(_ value1: String, _ value2: String, _ value3: String, preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          let format = NSLocalizedString("test_format_key_with_3_parameters", bundle: hostingBundle, comment: "")
          return String(format: format, locale: applicationLocale, value1, value2, value3)
        }

        guard let (locale, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "test_format_key_with_3_parameters"
        }

        let format = NSLocalizedString("test_format_key_with_3_parameters", bundle: bundle, comment: "")
        return String(format: format, locale: locale, value1, value2, value3)
      }

      /// en translation: Formated Strings [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func menu_formated_strings_button_title(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("menu_formated_strings_button_title", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "menu_formated_strings_button_title"
        }

        return NSLocalizedString("menu_formated_strings_button_title", bundle: bundle, comment: "")
      }

      /// en translation: In Bundle [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func settings_in_bundle(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("settings_in_bundle", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "settings_in_bundle"
        }

        return NSLocalizedString("settings_in_bundle", bundle: bundle, comment: "")
      }

      /// en translation: In SDK [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func settings_in_sdk(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("settings_in_sdk", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "settings_in_sdk"
        }

        return NSLocalizedString("settings_in_sdk", bundle: bundle, comment: "")
      }

      /// en translation: Label 123 [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func details_label(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("details_label", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "details_label"
        }

        return NSLocalizedString("details_label", bundle: bundle, comment: "")
      }

      /// en translation: Main Screen [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func main_title(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("main_title", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "main_title"
        }

        return NSLocalizedString("main_title", bundle: bundle, comment: "")
      }

      /// en translation: Main [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func menu_main_button_title(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("menu_main_button_title", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "menu_main_button_title"
        }

        return NSLocalizedString("menu_main_button_title", bundle: bundle, comment: "")
      }

      /// en translation: Parameter [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func test_parameter(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("test_parameter", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "test_parameter"
        }

        return NSLocalizedString("test_parameter", bundle: bundle, comment: "")
      }

      /// en translation: Placeholder [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func details_textfield_placeholder(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("details_textfield_placeholder", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "details_textfield_placeholder"
        }

        return NSLocalizedString("details_textfield_placeholder", bundle: bundle, comment: "")
      }

      /// en translation: Plurals [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func plurals_title(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("plurals_title", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "plurals_title"
        }

        return NSLocalizedString("plurals_title", bundle: bundle, comment: "")
      }

      /// en translation: Reload UI [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func main_reload_ui_button(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("main_reload_ui_button", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "main_reload_ui_button"
        }

        return NSLocalizedString("main_reload_ui_button", bundle: bundle, comment: "")
      }

      /// en translation: Settings [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func menu_settings_button_title(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("menu_settings_button_title", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "menu_settings_button_title"
        }

        return NSLocalizedString("menu_settings_button_title", bundle: bundle, comment: "")
      }

      /// en translation: Show Details [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func main_show_details_button(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("main_show_details_button", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "main_show_details_button"
        }

        return NSLocalizedString("main_show_details_button", bundle: bundle, comment: "")
      }

      /// en translation: Strings [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func strings_title(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("strings_title", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "strings_title"
        }

        return NSLocalizedString("strings_title", bundle: bundle, comment: "")
      }

      /// en translation: Test [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func test_key(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("test_key", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "test_key"
        }

        return NSLocalizedString("test_key", bundle: bundle, comment: "")
      }

      /// en translation: Test parameter - %@ [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func test_format_key_with_1_parameter(_ value1: String, preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          let format = NSLocalizedString("test_format_key_with_1_parameter", bundle: hostingBundle, comment: "")
          return String(format: format, locale: applicationLocale, value1)
        }

        guard let (locale, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "test_format_key_with_1_parameter"
        }

        let format = NSLocalizedString("test_format_key_with_1_parameter", bundle: bundle, comment: "")
        return String(format: format, locale: locale, value1)
      }

      /// en translation: Test parameter - %@ [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func test_with_format_key(_ value1: String, preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          let format = NSLocalizedString("test_with_format_key", bundle: hostingBundle, comment: "")
          return String(format: format, locale: applicationLocale, value1)
        }

        guard let (locale, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "test_with_format_key"
        }

        let format = NSLocalizedString("test_with_format_key", bundle: bundle, comment: "")
        return String(format: format, locale: locale, value1)
      }

      /// en translation: Value [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func details_segmentedControl_0(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("details_segmentedControl_0", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "details_segmentedControl_0"
        }

        return NSLocalizedString("details_segmentedControl_0", bundle: bundle, comment: "")
      }

      /// en translation: Value1 [BUNDLE]
      ///
      /// Locales: en, de, uk
      static func details_segmentedControl_1(preferredLanguages: [String]? = nil) -> String {
        guard let preferredLanguages = preferredLanguages else {
          return NSLocalizedString("details_segmentedControl_1", bundle: hostingBundle, comment: "")
        }

        guard let (_, bundle) = localeBundle(tableName: "Localizable", preferredLanguages: preferredLanguages) else {
          return "details_segmentedControl_1"
        }

        return NSLocalizedString("details_segmentedControl_1", bundle: bundle, comment: "")
      }

      fileprivate init() {}
    }

    fileprivate init() {}
  }

  fileprivate struct intern: Rswift.Validatable {
    fileprivate static func validate() throws {
      try _R.validate()
    }

    fileprivate init() {}
  }

  fileprivate class Class {}

  fileprivate init() {}
}

struct _R: Rswift.Validatable {
  static func validate() throws {
    #if os(iOS) || os(tvOS)
    try storyboard.validate()
    #endif
  }

  #if os(iOS) || os(tvOS)
  struct storyboard: Rswift.Validatable {
    static func validate() throws {
      #if os(iOS) || os(tvOS)
      try detailsVC.validate()
      #endif
      #if os(iOS) || os(tvOS)
      try launchScreen.validate()
      #endif
      #if os(iOS) || os(tvOS)
      try mainViewController.validate()
      #endif
      #if os(iOS) || os(tvOS)
      try menuVC.validate()
      #endif
      #if os(iOS) || os(tvOS)
      try pluralsVC.validate()
      #endif
      #if os(iOS) || os(tvOS)
      try settingsVC.validate()
      #endif
      #if os(iOS) || os(tvOS)
      try stringsVC.validate()
      #endif
    }

    #if os(iOS) || os(tvOS)
    struct detailsVC: Rswift.StoryboardResourceType, Rswift.Validatable {
      let bundle = R.hostingBundle
      let detailsVC = StoryboardViewControllerResource<DetailsVC>(identifier: "DetailsVC")
      let name = "DetailsVC"

      func detailsVC(_: Void = ()) -> DetailsVC? {
        return UIKit.UIStoryboard(resource: self).instantiateViewController(withResource: detailsVC)
      }

      static func validate() throws {
        if #available(iOS 11.0, tvOS 11.0, *) {
        }
        if _R.storyboard.detailsVC().detailsVC() == nil { throw Rswift.ValidationError(description:"[R.swift] ViewController with identifier 'detailsVC' could not be loaded from storyboard 'DetailsVC' as 'DetailsVC'.") }
      }

      fileprivate init() {}
    }
    #endif

    #if os(iOS) || os(tvOS)
    struct launchScreen: Rswift.StoryboardResourceWithInitialControllerType, Rswift.Validatable {
      typealias InitialController = UIKit.UIViewController

      let bundle = R.hostingBundle
      let name = "LaunchScreen"

      static func validate() throws {
        if #available(iOS 11.0, tvOS 11.0, *) {
        }
      }

      fileprivate init() {}
    }
    #endif

    #if os(iOS) || os(tvOS)
    struct mainViewController: Rswift.StoryboardResourceType, Rswift.Validatable {
      let bundle = R.hostingBundle
      let mainViewController = StoryboardViewControllerResource<MainViewController>(identifier: "MainViewController")
      let name = "MainViewController"

      func mainViewController(_: Void = ()) -> MainViewController? {
        return UIKit.UIStoryboard(resource: self).instantiateViewController(withResource: mainViewController)
      }

      static func validate() throws {
        if #available(iOS 11.0, tvOS 11.0, *) {
        }
        if _R.storyboard.mainViewController().mainViewController() == nil { throw Rswift.ValidationError(description:"[R.swift] ViewController with identifier 'mainViewController' could not be loaded from storyboard 'MainViewController' as 'MainViewController'.") }
      }

      fileprivate init() {}
    }
    #endif

    #if os(iOS) || os(tvOS)
    struct menuVC: Rswift.StoryboardResourceType, Rswift.Validatable {
      let bundle = R.hostingBundle
      let menuVC = StoryboardViewControllerResource<MenuVC>(identifier: "MenuVC")
      let name = "MenuVC"

      func menuVC(_: Void = ()) -> MenuVC? {
        return UIKit.UIStoryboard(resource: self).instantiateViewController(withResource: menuVC)
      }

      static func validate() throws {
        if #available(iOS 11.0, tvOS 11.0, *) {
        }
        if _R.storyboard.menuVC().menuVC() == nil { throw Rswift.ValidationError(description:"[R.swift] ViewController with identifier 'menuVC' could not be loaded from storyboard 'MenuVC' as 'MenuVC'.") }
      }

      fileprivate init() {}
    }
    #endif

    #if os(iOS) || os(tvOS)
    struct pluralsVC: Rswift.StoryboardResourceType, Rswift.Validatable {
      let bundle = R.hostingBundle
      let name = "PluralsVC"
      let pluralsVC = StoryboardViewControllerResource<PluralsVC>(identifier: "PluralsVC")

      func pluralsVC(_: Void = ()) -> PluralsVC? {
        return UIKit.UIStoryboard(resource: self).instantiateViewController(withResource: pluralsVC)
      }

      static func validate() throws {
        if #available(iOS 11.0, tvOS 11.0, *) {
        }
        if _R.storyboard.pluralsVC().pluralsVC() == nil { throw Rswift.ValidationError(description:"[R.swift] ViewController with identifier 'pluralsVC' could not be loaded from storyboard 'PluralsVC' as 'PluralsVC'.") }
      }

      fileprivate init() {}
    }
    #endif

    #if os(iOS) || os(tvOS)
    struct settingsVC: Rswift.StoryboardResourceType, Rswift.Validatable {
      let bundle = R.hostingBundle
      let name = "SettingsVC"
      let settingsVC = StoryboardViewControllerResource<SettingsVC>(identifier: "SettingsVC")

      func settingsVC(_: Void = ()) -> SettingsVC? {
        return UIKit.UIStoryboard(resource: self).instantiateViewController(withResource: settingsVC)
      }

      static func validate() throws {
        if #available(iOS 11.0, tvOS 11.0, *) {
        }
        if _R.storyboard.settingsVC().settingsVC() == nil { throw Rswift.ValidationError(description:"[R.swift] ViewController with identifier 'settingsVC' could not be loaded from storyboard 'SettingsVC' as 'SettingsVC'.") }
      }

      fileprivate init() {}
    }
    #endif

    #if os(iOS) || os(tvOS)
    struct stringsVC: Rswift.StoryboardResourceType, Rswift.Validatable {
      let bundle = R.hostingBundle
      let name = "StringsVC"
      let stringsVC = StoryboardViewControllerResource<StringsVC>(identifier: "StringsVC")

      func stringsVC(_: Void = ()) -> StringsVC? {
        return UIKit.UIStoryboard(resource: self).instantiateViewController(withResource: stringsVC)
      }

      static func validate() throws {
        if #available(iOS 11.0, tvOS 11.0, *) {
        }
        if _R.storyboard.stringsVC().stringsVC() == nil { throw Rswift.ValidationError(description:"[R.swift] ViewController with identifier 'stringsVC' could not be loaded from storyboard 'StringsVC' as 'StringsVC'.") }
      }

      fileprivate init() {}
    }
    #endif

    fileprivate init() {}
  }
  #endif

  fileprivate init() {}
}
